/*****************************************************
Project :keypad with 1 adc 
Version : 
Date    : 10/6/2012
Author  : hadi                            
Company : kh73                            
Comments: 
Chip type           : ATmega8
Program type        : Application
Clock frequency     : 1.000000 MHz
Memory model        : Small
External SRAM size  : 0
Data Stack size     : 256
*****************************************************/

// CodeVisionAVR C Compiler
// (C) 1998-2004 Pavel Haiduc, HP InfoTech S.R.L.

// I/O registers definitions for the ATmega8


#pragma used+
#pragma used+
sfrb TWBR=0;
sfrb TWSR=1;
sfrb TWAR=2;
sfrb TWDR=3;
sfrb ADCL=4;
sfrb ADCH=5;
sfrw ADCW=4;      // 16 bit access
sfrb ADCSRA=6;
sfrb ADMUX=7;
sfrb ACSR=8;
sfrb UBRRL=9;
sfrb UCSRB=0xa;
sfrb UCSRA=0xb;
sfrb UDR=0xc;
sfrb SPCR=0xd;
sfrb SPSR=0xe;
sfrb SPDR=0xf;
sfrb PIND=0x10;
sfrb DDRD=0x11;
sfrb PORTD=0x12;
sfrb PINC=0x13;
sfrb DDRC=0x14;
sfrb PORTC=0x15;
sfrb PINB=0x16;
sfrb DDRB=0x17;
sfrb PORTB=0x18;
sfrb EECR=0x1c;
sfrb EEDR=0x1d;
sfrb EEARL=0x1e;
sfrb EEARH=0x1f;
sfrw EEAR=0x1e;   // 16 bit access
sfrb UBRRH=0x20;
sfrb UCSRC=0X20;
sfrb WDTCR=0x21;
sfrb ASSR=0x22;
sfrb OCR2=0x23;
sfrb TCNT2=0x24;
sfrb TCCR2=0x25;
sfrb ICR1L=0x26;
sfrb ICR1H=0x27;
sfrw ICR1=0x26;   // 16 bit access
sfrb OCR1BL=0x28;
sfrb OCR1BH=0x29;
sfrw OCR1B=0x28;  // 16 bit access
sfrb OCR1AL=0x2a;
sfrb OCR1AH=0x2b;
sfrw OCR1A=0x2a;  // 16 bit access
sfrb TCNT1L=0x2c;
sfrb TCNT1H=0x2d;
sfrw TCNT1=0x2c;  // 16 bit access
sfrb TCCR1B=0x2e;
sfrb TCCR1A=0x2f;
sfrb SFIOR=0x30;
sfrb OSCCAL=0x31;
sfrb TCNT0=0x32;
sfrb TCCR0=0x33;
sfrb MCUCSR=0x34;
sfrb MCUCR=0x35;
sfrb TWCR=0x36;
sfrb SPMCR=0x37;
sfrb TIFR=0x38;
sfrb TIMSK=0x39;
sfrb GIFR=0x3a;
sfrb GICR=0x3b;
sfrb SPL=0x3d;
sfrb SPH=0x3e;
sfrb SREG=0x3f;
#pragma used-

// Interrupt vectors definitions


// Needed by the power management functions (sleep.h)
#asm
	#ifndef __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70
	.EQU __sm_adc_noise_red=0x10
	.SET power_ctrl_reg=mcucr
	#endif
#endasm


#asm
   .equ __lcd_port=0x12 ;PORTD
#endasm
/* LCD driver routines

  CodeVisionAVR C Compiler
  (C) 1998-2003 Pavel Haiduc, HP InfoTech S.R.L.

  BEFORE #include -ING THIS FILE YOU
  MUST DECLARE THE I/O ADDRESS OF THE
  DATA REGISTER OF THE PORT AT WHICH
  THE LCD IS CONNECTED!

  EXAMPLE FOR PORTB:

    #asm
        .equ __lcd_port=0x18
    #endasm
    #include <lcd.h>

*/


#pragma used+
#pragma used+

void _lcd_ready(void);
void _lcd_write_data(unsigned char data);
// write a byte to the LCD character generator or display RAM
void lcd_write_byte(unsigned char addr, unsigned char data);
// read a byte from the LCD character generator or display RAM
unsigned char lcd_read_byte(unsigned char addr);
// set the LCD display position  x=0..39 y=0..3
void lcd_gotoxy(unsigned char x, unsigned char y);
// clear the LCD
void lcd_clear(void);
void lcd_putchar(char c);
// write the string str located in SRAM to the LCD
void lcd_puts(char *str);
// write the string str located in FLASH to the LCD
void lcd_putsf(char flash *str);
// initialize the LCD controller
unsigned char lcd_init(unsigned char lcd_columns);

#pragma used-
#pragma library lcd.lib


// CodeVisionAVR C Compiler
// (C) 1998-2000 Pavel Haiduc, HP InfoTech S.R.L.


#pragma used+
#pragma used+

void delay_us(unsigned int n);
void delay_ms(unsigned int n);

#pragma used-

// Read the AD conversion result
unsigned int read_adc(unsigned char adc_input)
{
ADMUX=adc_input | (0x40 & 0xff);
delay_us(10);
ADCSRA|=0x40;
while ((ADCSRA & 0x10)==0);
ADCSRA|=0x10;
return ADCW;
}


void main(void)
{
int a;
PORTC=0x00;
DDRC=0x00;
ADMUX=0x40 & 0xff;
ADCSRA=0x83;
lcd_init(16);
lcd_gotoxy(0,0);
lcd_putsf("WWW.IranLED.COM");     
delay_ms(2000);
lcd_clear();
while (1)
      {
      a=read_adc(0);
      if (a==2){
      lcd_gotoxy(0,0);
      lcd_putsf("  ");
      };
      //**************
      if (a==362){
      lcd_gotoxy(0,0);
      lcd_putsf("7");
      };              
      //**************
      if (a==352){
      lcd_gotoxy(0,0);
      lcd_putsf("4");
      };              
      //**************
      if (a==340){
      lcd_gotoxy(0,0);
      lcd_putsf("1");
      };              
      //**************
      if (a==330){
      lcd_gotoxy(0,0);
      lcd_putsf("on");
      };              
      //**************
      if (a==559){
      lcd_gotoxy(0,0);
      lcd_putsf("8");
      };              
      //**************
      if (a==535){
      lcd_gotoxy(0,0);
      lcd_putsf("5");
      };              
      //**************
      if (a==508){
      lcd_gotoxy(0,0);
      lcd_putsf("2");
      };              
      //**************
      if (a==486){
      lcd_gotoxy(0,0);
      lcd_putsf("0");
      };              
      //**************
      if (a==773){
      lcd_gotoxy(0,0);
      lcd_putsf("9");
      };              
      //**************
      if (a==727){
      lcd_gotoxy(0,0);
      lcd_putsf("6");
      };              
      //**************
      if (a==679){
      lcd_gotoxy(0,0);
      lcd_putsf("3");
      };              
      //**************
      if (a==640){
      lcd_gotoxy(0,0);
      lcd_putsf("=");
      };              
      //**************
      if (a==1023){
      lcd_gotoxy(0,0);
      lcd_putsf("/");
      };              
      //**************
      if (a==945){
      lcd_gotoxy(0,0);
      lcd_putsf("X");
      };              
      //**************
      if (a==865){
      lcd_gotoxy(0,0);
      lcd_putsf("-");
      };              
      //**************
      if (a==803){
      lcd_gotoxy(0,0);
      lcd_putsf("+");
      };              
      //**************
      };
}
