
;CodeVisionAVR C Compiler V1.25.8 Standard
;(C) Copyright 1998-2007 Pavel Haiduc, HP InfoTech s.r.l.
;http://www.hpinfotech.com

;Chip type              : ATmega16
;Program type           : Application
;Clock frequency        : 0.500000 MHz
;Memory model           : Small
;Optimize for           : Size
;(s)printf features     : int, width
;(s)scanf features      : int, width
;External SRAM size     : 0
;Data Stack size        : 256 byte(s)
;Heap size              : 0 byte(s)
;Promote char to int    : No
;char is unsigned       : Yes
;8 bit enums            : Yes
;Word align FLASH struct: No
;Enhanced core instructions    : On
;Smart register allocation : On
;Automatic register allocation : On

	#pragma AVRPART ADMIN PART_NAME ATmega16
	#pragma AVRPART MEMORY PROG_FLASH 16384
	#pragma AVRPART MEMORY EEPROM 512
	#pragma AVRPART MEMORY INT_SRAM SIZE 1024
	#pragma AVRPART MEMORY INT_SRAM START_ADDR 0x60

	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDB1MN
	SUBI R30,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDB2MN
	SUBI R26,LOW(-@0-(@1))
	.ENDM
	.MACRO __ADDW1MN
	SUBI R30,LOW(-@0-(@1))
	SBCI R31,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW2MN
	SUBI R26,LOW(-@0-(@1))
	SBCI R27,HIGH(-@0-(@1))
	.ENDM
	.MACRO __ADDW1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1FN
	SUBI R30,LOW(-2*@0-(@1))
	SBCI R31,HIGH(-2*@0-(@1))
	SBCI R22,BYTE3(-2*@0-(@1))
	.ENDM
	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDBMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ANDWMNN
	LDS  R30,@0+@1
	ANDI R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ANDI R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORBMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	.ENDM

	.MACRO __ORWMNN
	LDS  R30,@0+@1
	ORI  R30,LOW(@2)
	STS  @0+@1,R30
	LDS  R30,@0+@1+1
	ORI  R30,HIGH(@2)
	STS  @0+@1+1,R30
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	LDI  R30,0
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __PUTD2S
	STD  Y+@0,R26
	STD  Y+@0+1,R27
	STD  Y+@0+2,R24
	STD  Y+@0+3,R25
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTD1M
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTD1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	LDI  R22,BYTE3(2*@0+@1)
	LDI  R23,BYTE4(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTBRM
	LDI  R@0,LOW(@1)
	.ENDM

	.MACRO __POINTWRM
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __POINTBRMN
	LDI  R@0,LOW(@1+@2)
	.ENDM

	.MACRO __POINTWRMN
	LDI  R@0,LOW(@2+@3)
	LDI  R@1,HIGH(@2+@3)
	.ENDM

	.MACRO __POINTWRFN
	LDI  R@0,LOW(@2*2+@3)
	LDI  R@1,HIGH(@2*2+@3)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETB1HMN
	LDS  R31,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@0,@1+@2
	.ENDM

	.MACRO __GETWRMN
	LDS  R@0,@2+@3
	LDS  R@1,@2+@3+1
	.ENDM

	.MACRO __GETWRZ
	LDD  R@0,Z+@2
	LDD  R@1,Z+@2+1
	.ENDM

	.MACRO __GETD2Z
	LDD  R26,Z+@0
	LDD  R27,Z+@0+1
	LDD  R24,Z+@0+2
	LDD  R25,Z+@0+3
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBR0MN
	STS  @0+@1,R0
	.ENDM

	.MACRO __PUTDZ2
	STD  Z+@0,R26
	STD  Z+@0+1,R27
	STD  Z+@0+2,R24
	STD  Z+@0+3,R25
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __PUTBZR
	STD  Z+@1,R@0
	.ENDM

	.MACRO __PUTWZR
	STD  Z+@2,R@0
	STD  Z+@2+1,R@1
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __CALL1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	CALL __GETW1PF
	ICALL
	.ENDM

	.MACRO __CALL2EN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	CALL __EEPROMRDW
	ICALL
	.ENDM

	.MACRO __GETW1STACK
	IN   R26,SPL
	IN   R27,SPH
	ADIW R26,@0+1
	LD   R30,X+
	LD   R31,X
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RN
	MOVW R26,R@0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RNS
	MOVW R26,R@0
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RNS
	MOVW R26,R@0
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RON
	MOV  R26,R@0
	MOV  R27,R@1
	SUBI R26,LOW(-@2)
	SBCI R27,HIGH(-@2)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X,R30
	.ENDM

	.MACRO __PUTW1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1RONS
	MOV  R26,R@0
	MOV  R27,R@1
	ADIW R26,@2
	CALL __PUTDP1
	.ENDM


	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETB1HSX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTD2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z+,R27
	ST   Z+,R24
	ST   Z,R25
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOVW R30,R0
	.ENDM

	.MACRO __MULBRR0
	MULS R@0,R@1
	.ENDM

	.MACRO __MULBRRU0
	MUL  R@0,R@1
	.ENDM

	.MACRO __MULBNWRU
	LDI  R26,@2
	MUL  R26,R@0
	MOVW R30,R0
	MUL  R26,R@1
	ADD  R31,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "saat.vec"
	.INCLUDE "saat.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	OUT  WDTCR,R30

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x400)
	LDI  R25,HIGH(0x400)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R24,Z+
	LPM  R25,Z+
	SBIW R24,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x45F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x45F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x160)
	LDI  R29,HIGH(0x160)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x160
;       1 /*''''''''''''''''''''''''''''in the name of GOD''''''''''''''''''''''''''''''''
;       2 '          Salam in yek barname saat ast ke ba 7segment kar mi konad           '
;       3 ' Az emkanat in saat :nemayesh saat roye 7 segmen,nemayesh tarikh shamsi roye  '
;       4 '                   7segment va hamchenin nemayesh dema ast                    '
;       5 '           Hadi KHosravi _ Kerman _ Bardsir 1391/07/10 "23:51:00"             '
;       6 '''''''''''''''''''''''''''''hadikh73@yahoo.com'''''''''''''''''''''''''''''''*/
;       7 #include <mega16.h>
;       8 	#ifndef __SLEEP_DEFINED__
	#ifndef __SLEEP_DEFINED__
;       9 	#define __SLEEP_DEFINED__
	#define __SLEEP_DEFINED__
;      10 	.EQU __se_bit=0x40
	.EQU __se_bit=0x40
;      11 	.EQU __sm_mask=0xB0
	.EQU __sm_mask=0xB0
;      12 	.EQU __sm_powerdown=0x20
	.EQU __sm_powerdown=0x20
;      13 	.EQU __sm_powersave=0x30
	.EQU __sm_powersave=0x30
;      14 	.EQU __sm_standby=0xA0
	.EQU __sm_standby=0xA0
;      15 	.EQU __sm_ext_standby=0xB0
	.EQU __sm_ext_standby=0xB0
;      16 	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_adc_noise_red=0x10
;      17 	.SET power_ctrl_reg=mcucr
	.SET power_ctrl_reg=mcucr
;      18 	#endif
	#endif
;      19 #include <delay.h>
;      20 char sega[10]={0x40,0x79,0x24,0x30,0x19,0x12,0x02,0x78,0x00,0x10};
_sega:
	.BYTE 0xA
;      21 int s,d=5,e;
;      22 // Timer 2 overflow interrupt service routine
;      23 interrupt [TIM2_OVF] void timer2_ovf_isr(void)
;      24 {

	.CSEG
_timer2_ovf_isr:
	ST   -Y,R0
	ST   -Y,R30
	ST   -Y,R31
	IN   R30,SREG
	ST   -Y,R30
;      25    e++;
	MOVW R30,R8
	ADIW R30,1
	MOVW R8,R30
;      26    if(e==2){
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CP   R30,R8
	CPC  R31,R9
	BRNE _0x5
;      27    e=0;
	CLR  R8
	CLR  R9
;      28    s++;
	MOVW R30,R4
	ADIW R30,1
	MOVW R4,R30
;      29    d++;
	MOVW R30,R6
	ADIW R30,1
	MOVW R6,R30
;      30    }
;      31         if (e==0) {
_0x5:
	MOV  R0,R8
	OR   R0,R9
	BRNE _0x6
;      32         PORTA.4=1;
	SBI  0x1B,4
;      33         }
;      34         else{
	RJMP _0x9
_0x6:
;      35         PORTA.4=0;
	CBI  0x1B,4
;      36         }
_0x9:
;      37               if (s==0) {
	MOV  R0,R4
	OR   R0,R5
	BRNE _0xC
;      38               PORTA.1=1;
	SBI  0x1B,1
;      39               }
;      40                else{
	RJMP _0xF
_0xC:
;      41               PORTA.1=0;
	CBI  0x1B,1
;      42               }
_0xF:
;      43 }
	LD   R30,Y+
	OUT  SREG,R30
	LD   R31,Y+
	LD   R30,Y+
	LD   R0,Y+
	RETI
;      44 
;      45 
;      46 #define ADC_VREF_TYPE 0x00
;      47 
;      48 // Read the AD conversion result
;      49 unsigned int read_adc(unsigned char adc_input)
;      50 {
_read_adc:
;      51 ADMUX=adc_input | (ADC_VREF_TYPE & 0xff);
;	adc_input -> Y+0
	LD   R30,Y
	OUT  0x7,R30
;      52 // Delay needed for the stabilization of the ADC input voltage
;      53 delay_us(10);
	__DELAY_USB 2
;      54 // Wait for the AD conversion to complete
;      55 while ((ADCSRA & 0x10)==0);
_0x12:
	SBIS 0x6,4
	RJMP _0x12
;      56 ADCSRA|=0x10;
	SBI  0x6,4
;      57 return ADCW;
	IN   R30,0x4
	IN   R31,0x4+1
	ADIW R28,1
	RET
;      58 }
;      59 
;      60 // Declare your global variables here
;      61 
;      62 void main(void)
;      63 {
_main:
;      64 // Declare your local variables here
;      65 int m=51,h=23,r=10,mo=7,sa=1391, a1,a2,a3,a4,a5,a6,a7,a8,a9,a10,a11,a12,a13,a14,a15,a16;
;      66 int dama,me,me1,incr,decr;
;      67 // Input/Output Ports initialization
;      68 // Port A initialization
;      69 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=In Func2=In Func1=Out Func0=In
;      70 // State7=0 State6=0 State5=0 State4=0 State3=T State2=T State1=0 State0=T
;      71 PORTA=0x00;
	SBIW R28,46
	LDI  R24,4
	LDI  R26,LOW(42)
	LDI  R27,HIGH(42)
	LDI  R30,LOW(_0x15*2)
	LDI  R31,HIGH(_0x15*2)
	CALL __INITLOCB
;	m -> R16,R17
;	h -> R18,R19
;	r -> R20,R21
;	mo -> Y+44
;	sa -> Y+42
;	a1 -> Y+40
;	a2 -> Y+38
;	a3 -> Y+36
;	a4 -> Y+34
;	a5 -> Y+32
;	a6 -> Y+30
;	a7 -> Y+28
;	a8 -> Y+26
;	a9 -> Y+24
;	a10 -> Y+22
;	a11 -> Y+20
;	a12 -> Y+18
;	a13 -> Y+16
;	a14 -> Y+14
;	a15 -> Y+12
;	a16 -> Y+10
;	dama -> Y+8
;	me -> Y+6
;	me1 -> Y+4
;	incr -> Y+2
;	decr -> Y+0
	LDI  R16,51
	LDI  R17,0
	LDI  R18,23
	LDI  R19,0
	LDI  R20,10
	LDI  R21,0
	LDI  R30,LOW(0)
	OUT  0x1B,R30
;      72 DDRA=0xF2;
	LDI  R30,LOW(242)
	OUT  0x1A,R30
;      73 
;      74 // Port B initialization
;      75 // Func7=Out Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;      76 // State7=0 State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
;      77 PORTB=0x00;
	LDI  R30,LOW(0)
	OUT  0x18,R30
;      78 DDRB=0xFF;
	LDI  R30,LOW(255)
	OUT  0x17,R30
;      79 
;      80 // Port C initialization
;      81 // Func7=In Func6=In Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;      82 // State7=T State6=T State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
;      83 PORTC=0x00;
	LDI  R30,LOW(0)
	OUT  0x15,R30
;      84 DDRC=0x3F;
	LDI  R30,LOW(63)
	OUT  0x14,R30
;      85 
;      86 // Port D initialization
;      87 // Func7=In Func6=Out Func5=Out Func4=Out Func3=Out Func2=Out Func1=Out Func0=Out
;      88 // State7=T State6=0 State5=0 State4=0 State3=0 State2=0 State1=0 State0=0
;      89 PORTD=0x00;
	LDI  R30,LOW(0)
	OUT  0x12,R30
;      90 DDRD=0x7F;
	LDI  R30,LOW(127)
	OUT  0x11,R30
;      91 
;      92 // Timer/Counter 2 initialization
;      93 // Clock source: TOSC1 pin
;      94 // Clock value: PCK2/128
;      95 // Mode: Normal top=FFh
;      96 // OC2 output: Disconnected
;      97 ASSR=0x08;
	LDI  R30,LOW(8)
	OUT  0x22,R30
;      98 TCCR2=0x04;
	LDI  R30,LOW(4)
	OUT  0x25,R30
;      99 TCNT2=0x00;
	LDI  R30,LOW(0)
	OUT  0x24,R30
;     100 
;     101 // Timer(s)/Counter(s) Interrupt(s) initialization
;     102 TIMSK=0x40;
	LDI  R30,LOW(64)
	OUT  0x39,R30
;     103 
;     104 // ADC initialization
;     105 // ADC Clock frequency: 125.000 kHz
;     106 // ADC Voltage Reference: AREF pin
;     107 // ADC Auto Trigger Source: None
;     108 ADMUX=ADC_VREF_TYPE & 0xff;
	LDI  R30,LOW(0)
	OUT  0x7,R30
;     109 ADCSRA=0x82;
	LDI  R30,LOW(130)
	OUT  0x6,R30
;     110 
;     111 // Global enable interrupts
;     112 #asm("sei")
	sei
;     113 
;     114 while (1)
_0x16:
;     115       {
;     116       //***********************************************************************
;     117       if ((PINA.2==1) && (me1==0)) {
	SBIS 0x19,2
	RJMP _0x1A
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	CALL __CPW02
	BREQ _0x1B
_0x1A:
	RJMP _0x19
_0x1B:
;     118       me++;
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
;     119       me1=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+4,R30
	STD  Y+4+1,R31
;     120       }
;     121        if ((PINA.2==0) && (me1==1)) {
_0x19:
	SBIC 0x19,2
	RJMP _0x1D
	LDD  R26,Y+4
	LDD  R27,Y+4+1
	SBIW R26,1
	BREQ _0x1E
_0x1D:
	RJMP _0x1C
_0x1E:
;     122        me1=0;
	LDI  R30,0
	STD  Y+4,R30
	STD  Y+4+1,R30
;     123        }
;     124         if (me==7) {
_0x1C:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,7
	BRNE _0x1F
;     125        me=0;
	LDI  R30,0
	STD  Y+6,R30
	STD  Y+6+1,R30
;     126        }
;     127       if (me==0){
_0x1F:
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	SBIW R30,0
	BRNE _0x20
;     128         if(s>59){
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	CP   R30,R4
	CPC  R31,R5
	BRGE _0x21
;     129         s=0;
	CLR  R4
	CLR  R5
;     130         m++;
	__ADDWRN 16,17,1
;     131         }
;     132         if(m>59){
_0x21:
	__CPWRN 16,17,60
	BRLT _0x22
;     133         m=0;
	__GETWRN 16,17,0
;     134         h++;
	__ADDWRN 18,19,1
;     135         }
;     136         if(h>23){
_0x22:
	__CPWRN 18,19,24
	BRLT _0x23
;     137         h=0;
	__GETWRN 18,19,0
;     138         r++;
	__ADDWRN 20,21,1
;     139         }
;     140         if(mo>6){
_0x23:
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	SBIW R26,7
	BRLT _0x24
;     141         if(r>31){
	__CPWRN 20,21,32
	BRLT _0x25
;     142         r=0;
	RCALL SUBOPT_0x0
;     143         mo++;
;     144         }
;     145         }
_0x25:
;     146         else{
	RJMP _0x26
_0x24:
;     147         if(r>30){
	__CPWRN 20,21,31
	BRLT _0x27
;     148         r=0;
	RCALL SUBOPT_0x0
;     149         mo++;
;     150         }
;     151         }
_0x27:
_0x26:
;     152         if (mo>12){
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	SBIW R26,13
	BRLT _0x28
;     153         mo=0;
	LDI  R30,0
	STD  Y+44,R30
	STD  Y+44+1,R30
;     154         sa++;
	LDD  R30,Y+42
	LDD  R31,Y+42+1
	ADIW R30,1
	STD  Y+42,R30
	STD  Y+42+1,R31
;     155         }
;     156       }
_0x28:
;     157       else{
	RJMP _0x29
_0x20:
;     158         if(s>59){
	LDI  R30,LOW(59)
	LDI  R31,HIGH(59)
	CP   R30,R4
	CPC  R31,R5
	BRGE _0x2A
;     159         s=0;
	CLR  R4
	CLR  R5
;     160         m++;
	__ADDWRN 16,17,1
;     161         }
;     162         if(m>59){
_0x2A:
	__CPWRN 16,17,60
	BRLT _0x2B
;     163         m=0;
	__GETWRN 16,17,0
;     164         }
;     165         if(h>23){
_0x2B:
	__CPWRN 18,19,24
	BRLT _0x2C
;     166         h=0;
	__GETWRN 18,19,0
;     167         }
;     168         if(mo>6){
_0x2C:
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	SBIW R26,7
	BRLT _0x2D
;     169         if(r>31){
	__CPWRN 20,21,32
	BRLT _0x2E
;     170         r=0;
	__GETWRN 20,21,0
;     171         }
;     172         }
_0x2E:
;     173         else{
	RJMP _0x2F
_0x2D:
;     174         if(r>30){
	__CPWRN 20,21,31
	BRLT _0x30
;     175         r=0;
	__GETWRN 20,21,0
;     176         }
;     177         }
_0x30:
_0x2F:
;     178         if (mo>12){
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	SBIW R26,13
	BRLT _0x31
;     179         mo=0;
	LDI  R30,0
	STD  Y+44,R30
	STD  Y+44+1,R30
;     180         }
;     181       }
_0x31:
_0x29:
;     182       //***************************
;     183       a1=s%10;
	MOVW R26,R4
	RCALL SUBOPT_0x1
	STD  Y+40,R30
	STD  Y+40+1,R31
;     184       a2=s/10;
	MOVW R26,R4
	RCALL SUBOPT_0x2
	STD  Y+38,R30
	STD  Y+38+1,R31
;     185       //**********
;     186       a3=m%10;
	MOVW R26,R16
	RCALL SUBOPT_0x1
	STD  Y+36,R30
	STD  Y+36+1,R31
;     187       a4=m/10;
	MOVW R26,R16
	RCALL SUBOPT_0x2
	STD  Y+34,R30
	STD  Y+34+1,R31
;     188       //**********
;     189       a5=h%10;
	MOVW R26,R18
	RCALL SUBOPT_0x1
	STD  Y+32,R30
	STD  Y+32+1,R31
;     190       a6=h/10;
	MOVW R26,R18
	RCALL SUBOPT_0x2
	STD  Y+30,R30
	STD  Y+30+1,R31
;     191       //**********
;     192       a7=r%10;
	MOVW R26,R20
	RCALL SUBOPT_0x1
	STD  Y+28,R30
	STD  Y+28+1,R31
;     193       a8=r/10;
	MOVW R26,R20
	RCALL SUBOPT_0x2
	STD  Y+26,R30
	STD  Y+26+1,R31
;     194       //**********
;     195       a9=mo%10;
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	RCALL SUBOPT_0x1
	STD  Y+24,R30
	STD  Y+24+1,R31
;     196       a10=mo/10;
	LDD  R26,Y+44
	LDD  R27,Y+44+1
	RCALL SUBOPT_0x2
	STD  Y+22,R30
	STD  Y+22+1,R31
;     197       //**********
;     198       a11=sa%10;
	LDD  R26,Y+42
	LDD  R27,Y+42+1
	RCALL SUBOPT_0x1
	STD  Y+20,R30
	STD  Y+20+1,R31
;     199       //**********
;     200       a12=sa%100;
	LDD  R26,Y+42
	LDD  R27,Y+42+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __MODW21
	STD  Y+18,R30
	STD  Y+18+1,R31
;     201       a12=a12/10;
	LDD  R26,Y+18
	LDD  R27,Y+18+1
	RCALL SUBOPT_0x2
	STD  Y+18,R30
	STD  Y+18+1,R31
;     202       //**********
;     203       a13=sa%1000;
	LDD  R26,Y+42
	LDD  R27,Y+42+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	CALL __MODW21
	STD  Y+16,R30
	STD  Y+16+1,R31
;     204       a13=a13/100;
	LDD  R26,Y+16
	LDD  R27,Y+16+1
	LDI  R30,LOW(100)
	LDI  R31,HIGH(100)
	CALL __DIVW21
	STD  Y+16,R30
	STD  Y+16+1,R31
;     205       //**********
;     206       a14=sa/1000;
	LDD  R26,Y+42
	LDD  R27,Y+42+1
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	CALL __DIVW21
	STD  Y+14,R30
	STD  Y+14+1,R31
;     207       //**********
;     208       a15=dama%10;
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	RCALL SUBOPT_0x1
	STD  Y+12,R30
	STD  Y+12+1,R31
;     209       a16=dama/10;
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	RCALL SUBOPT_0x2
	STD  Y+10,R30
	STD  Y+10+1,R31
;     210        //***************************
;     211       PORTC.0=1;
	SBI  0x15,0
;     212       PORTD=sega[a1];
	LDD  R30,Y+40
	LDD  R31,Y+40+1
	RCALL SUBOPT_0x3
;     213       if (me==1) {
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,1
	BRNE _0x34
;     214       PORTA.7=0;
	CBI  0x1B,7
;     215       }
;     216       else{
	RJMP _0x37
_0x34:
;     217       PORTA.7=1;
	SBI  0x1B,7
;     218       }
_0x37:
;     219       delay_ms(4);
	RCALL SUBOPT_0x4
;     220       PORTC.0=0;
	CBI  0x15,0
;     221       PORTC.1=1;
	SBI  0x15,1
;     222       PORTD=sega[a2];
	LDD  R30,Y+38
	LDD  R31,Y+38+1
	RCALL SUBOPT_0x3
;     223       //PORTD.7=1
;     224       delay_ms(4);
	RCALL SUBOPT_0x4
;     225       PORTC.1=0;
	CBI  0x15,1
;     226        PORTC.2=1;
	SBI  0x15,2
;     227       PORTD=sega[a3];
	LDD  R30,Y+36
	LDD  R31,Y+36+1
	RCALL SUBOPT_0x3
;     228       if (me==2) {
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,2
	BRNE _0x42
;     229       PORTA.7=0;
	CBI  0x1B,7
;     230       }
;     231       else{
	RJMP _0x45
_0x42:
;     232       PORTA.7=1;
	SBI  0x1B,7
;     233       }
_0x45:
;     234       delay_ms(4);
	RCALL SUBOPT_0x4
;     235       PORTC.2=0;
	CBI  0x15,2
;     236       PORTC.3=1;
	SBI  0x15,3
;     237       PORTD=sega[a4];
	LDD  R30,Y+34
	LDD  R31,Y+34+1
	RCALL SUBOPT_0x3
;     238       delay_ms(4);
	RCALL SUBOPT_0x4
;     239       PORTC.3=0;
	CBI  0x15,3
;     240        PORTC.4=1;
	SBI  0x15,4
;     241       PORTD=sega[a5];
	LDD  R30,Y+32
	LDD  R31,Y+32+1
	RCALL SUBOPT_0x3
;     242       if (me==3) {
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,3
	BRNE _0x50
;     243       PORTA.7=0;
	CBI  0x1B,7
;     244       }
;     245       else{
	RJMP _0x53
_0x50:
;     246       PORTA.7=1;
	SBI  0x1B,7
;     247       }
_0x53:
;     248       delay_ms(4);
	RCALL SUBOPT_0x4
;     249       PORTC.4=0;
	CBI  0x15,4
;     250       PORTC.5=1;
	SBI  0x15,5
;     251       PORTD=sega[a6];
	LDD  R30,Y+30
	LDD  R31,Y+30+1
	RCALL SUBOPT_0x3
;     252       delay_ms(4);
	RCALL SUBOPT_0x4
;     253       PORTC.5=0;
	CBI  0x15,5
;     254        PORTB.0=1;
	SBI  0x18,0
;     255       PORTD=sega[a7];
	LDD  R30,Y+28
	LDD  R31,Y+28+1
	RCALL SUBOPT_0x3
;     256       if (me==4) {
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,4
	BRNE _0x5E
;     257       PORTA.7=0;
	CBI  0x1B,7
;     258       }
;     259       else{
	RJMP _0x61
_0x5E:
;     260       PORTA.7=1;
	SBI  0x1B,7
;     261       }
_0x61:
;     262       delay_ms(4);
	RCALL SUBOPT_0x4
;     263       PORTB.0=0;
	CBI  0x18,0
;     264       PORTB.1=1;
	SBI  0x18,1
;     265       PORTD=sega[a8];
	LDD  R30,Y+26
	LDD  R31,Y+26+1
	RCALL SUBOPT_0x3
;     266       delay_ms(4);
	RCALL SUBOPT_0x4
;     267       PORTB.1=0;
	CBI  0x18,1
;     268        PORTB.2=1;
	SBI  0x18,2
;     269       PORTD=sega[a9];
	LDD  R30,Y+24
	LDD  R31,Y+24+1
	RCALL SUBOPT_0x3
;     270       if (me==5) {
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,5
	BRNE _0x6C
;     271       PORTA.7=0;
	CBI  0x1B,7
;     272       }
;     273       else{
	RJMP _0x6F
_0x6C:
;     274       PORTA.7=1;
	SBI  0x1B,7
;     275       }
_0x6F:
;     276       delay_ms(4);
	RCALL SUBOPT_0x4
;     277       PORTB.2=0;
	CBI  0x18,2
;     278       PORTB.3=1;
	SBI  0x18,3
;     279       PORTD=sega[a10];
	LDD  R30,Y+22
	LDD  R31,Y+22+1
	RCALL SUBOPT_0x3
;     280       delay_ms(4);
	RCALL SUBOPT_0x4
;     281       PORTB.3=0;
	CBI  0x18,3
;     282        PORTB.4=1;
	SBI  0x18,4
;     283       PORTD=sega[a11];
	LDD  R30,Y+20
	LDD  R31,Y+20+1
	RCALL SUBOPT_0x3
;     284       if (me==6) {
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,6
	BRNE _0x7A
;     285       PORTA.7=0;
	CBI  0x1B,7
;     286       }
;     287       else{
	RJMP _0x7D
_0x7A:
;     288       PORTA.7=1;
	SBI  0x1B,7
;     289       }
_0x7D:
;     290       delay_ms(4);
	RCALL SUBOPT_0x4
;     291       PORTB.4=0;
	CBI  0x18,4
;     292       PORTB.5=1;
	SBI  0x18,5
;     293       PORTD=sega[a12];
	LDD  R30,Y+18
	LDD  R31,Y+18+1
	RCALL SUBOPT_0x3
;     294       delay_ms(4);
	RCALL SUBOPT_0x4
;     295       PORTB.5=0;
	CBI  0x18,5
;     296        PORTB.6=1;
	SBI  0x18,6
;     297       PORTD=sega[a13];
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	RCALL SUBOPT_0x3
;     298       delay_ms(4);
	RCALL SUBOPT_0x4
;     299       PORTB.6=0;
	CBI  0x18,6
;     300       PORTB.7=1;
	SBI  0x18,7
;     301       PORTD=sega[a14];
	LDD  R30,Y+14
	LDD  R31,Y+14+1
	RCALL SUBOPT_0x3
;     302       delay_ms(4);
	RCALL SUBOPT_0x4
;     303       PORTB.7=0;
	CBI  0x18,7
;     304        PORTA.5=1;
	SBI  0x1B,5
;     305       PORTD=sega[a15];
	LDD  R30,Y+12
	LDD  R31,Y+12+1
	RCALL SUBOPT_0x3
;     306       PORTA.7=1;
	SBI  0x1B,7
;     307       delay_ms(4);
	RCALL SUBOPT_0x4
;     308       PORTA.5=0;
	CBI  0x1B,5
;     309       PORTA.6=1;
	SBI  0x1B,6
;     310       PORTD=sega[a16];
	LDD  R30,Y+10
	LDD  R31,Y+10+1
	RCALL SUBOPT_0x3
;     311       delay_ms(4);
	RCALL SUBOPT_0x4
;     312       PORTA.6=0;
	CBI  0x1B,6
;     313       //***********************************************************************
;     314     if (d==5) {
	LDI  R30,LOW(5)
	LDI  R31,HIGH(5)
	CP   R30,R6
	CPC  R31,R7
	BRNE _0x98
;     315       d=0;
	CLR  R6
	CLR  R7
;     316       // Start the AD conversion
;     317       ADCSRA|=0x40;
	SBI  0x6,6
;     318       dama=read_adc(3);
	LDI  R30,LOW(3)
	ST   -Y,R30
	RCALL _read_adc
	STD  Y+8,R30
	STD  Y+8+1,R31
;     319       dama=dama/2;
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(2)
	LDI  R31,HIGH(2)
	CALL __DIVW21
	STD  Y+8,R30
	STD  Y+8+1,R31
;     320     };
_0x98:
;     321       //***********************************************************************
;     322        if ((PINA.0==1) && (incr==0)) {
	SBIS 0x19,0
	RJMP _0x9A
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	CALL __CPW02
	BREQ _0x9B
_0x9A:
	RJMP _0x99
_0x9B:
;     323       incr=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	STD  Y+2,R30
	STD  Y+2+1,R31
;     324         if (me==1) {
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,1
	BRNE _0x9C
;     325         s=0;
	CLR  R4
	CLR  R5
;     326         }
;     327         if (me==2) {
_0x9C:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,2
	BRNE _0x9D
;     328         m++;
	__ADDWRN 16,17,1
;     329         }
;     330         if (me==3) {
_0x9D:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,3
	BRNE _0x9E
;     331         h++;
	__ADDWRN 18,19,1
;     332         }
;     333         if (me==4) {
_0x9E:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,4
	BRNE _0x9F
;     334         r++;
	__ADDWRN 20,21,1
;     335         }
;     336         if (me==5) {
_0x9F:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,5
	BRNE _0xA0
;     337         mo++;
	LDD  R30,Y+44
	LDD  R31,Y+44+1
	ADIW R30,1
	STD  Y+44,R30
	STD  Y+44+1,R31
;     338         }
;     339         if (me==6) {
_0xA0:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,6
	BRNE _0xA1
;     340         sa++;
	LDD  R30,Y+42
	LDD  R31,Y+42+1
	ADIW R30,1
	STD  Y+42,R30
	STD  Y+42+1,R31
;     341         }
;     342         }
_0xA1:
;     343        if ((PINA.0==0) && (incr==1)) {
_0x99:
	SBIC 0x19,0
	RJMP _0xA3
	LDD  R26,Y+2
	LDD  R27,Y+2+1
	SBIW R26,1
	BREQ _0xA4
_0xA3:
	RJMP _0xA2
_0xA4:
;     344        incr=0;
	LDI  R30,0
	STD  Y+2,R30
	STD  Y+2+1,R30
;     345        }
;     346        //'***********************************************************************
;     347       if ((PIND.7==1) && (decr==0)) {
_0xA2:
	SBIS 0x10,7
	RJMP _0xA6
	LD   R26,Y
	LDD  R27,Y+1
	CALL __CPW02
	BREQ _0xA7
_0xA6:
	RJMP _0xA5
_0xA7:
;     348       decr=1;
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	ST   Y,R30
	STD  Y+1,R31
;     349         if (me==1) {
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,1
	BRNE _0xA8
;     350         s=0;
	CLR  R4
	CLR  R5
;     351         }
;     352         if (me==2) {
_0xA8:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,2
	BRNE _0xA9
;     353         m--;
	__SUBWRN 16,17,1
;     354         }
;     355         if (me==3) {
_0xA9:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,3
	BRNE _0xAA
;     356         h--;
	__SUBWRN 18,19,1
;     357         }
;     358         if (me==4) {
_0xAA:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,4
	BRNE _0xAB
;     359         r--;
	__SUBWRN 20,21,1
;     360         }
;     361         if (me==5) {
_0xAB:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,5
	BRNE _0xAC
;     362         mo--;
	LDD  R30,Y+44
	LDD  R31,Y+44+1
	SBIW R30,1
	STD  Y+44,R30
	STD  Y+44+1,R31
;     363         }
;     364         if (me==6) {
_0xAC:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	SBIW R26,6
	BRNE _0xAD
;     365         sa--;
	LDD  R30,Y+42
	LDD  R31,Y+42+1
	SBIW R30,1
	STD  Y+42,R30
	STD  Y+42+1,R31
;     366         }
;     367         }
_0xAD:
;     368        if ((PIND.7==0) && (decr==1)) {
_0xA5:
	SBIC 0x10,7
	RJMP _0xAF
	LD   R26,Y
	LDD  R27,Y+1
	SBIW R26,1
	BREQ _0xB0
_0xAF:
	RJMP _0xAE
_0xB0:
;     369        decr=0;
	LDI  R30,0
	STD  Y+0,R30
	STD  Y+0+1,R30
;     370        }
;     371        //'***********************************************************************
;     372        };
_0xAE:
	RJMP _0x16
;     373 }
_0xB1:
	RJMP _0xB1


;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES, CODE SIZE REDUCTION:2 WORDS
SUBOPT_0x0:
	__GETWRN 20,21,0
	LDD  R30,Y+44
	LDD  R31,Y+44+1
	ADIW R30,1
	STD  Y+44,R30
	STD  Y+44+1,R31
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x1:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 7 TIMES, CODE SIZE REDUCTION:9 WORDS
SUBOPT_0x2:
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:27 WORDS
SUBOPT_0x3:
	SUBI R30,LOW(-_sega)
	SBCI R31,HIGH(-_sega)
	LD   R30,Z
	OUT  0x12,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 16 TIMES, CODE SIZE REDUCTION:57 WORDS
SUBOPT_0x4:
	LDI  R30,LOW(4)
	LDI  R31,HIGH(4)
	ST   -Y,R31
	ST   -Y,R30
	JMP  _delay_ms

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USB 0xA7
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ANEGW1:
	NEG  R31
	NEG  R30
	SBCI R31,0
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__CPW02:
	CLR  R0
	CP   R0,R26
	CPC  R0,R27
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

;END OF CODE MARKER
__END_OF_CODE:
